Attribute VB_Name = "Module1"
Option Explicit

Public Declare Function CreateWindowEx Lib "user32" Alias "CreateWindowExA" (ByVal dwExStyle As Long, ByVal lpClassName As String, ByVal lpWindowName As String, ByVal dwStyle As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hWndParent As Long, ByVal hMenu As Long, ByVal hInstance As Long, lpParam As Any) As Long
Public Declare Function TranslateMessage Lib "user32" (lpMsg As Msg) As Long
Public Declare Function DispatchMessage Lib "user32" Alias "DispatchMessageA" (lpMsg As Msg) As Long
Public Declare Function GetMessage Lib "user32" Alias "GetMessageA" (lpMsg As Msg, ByVal hwnd As Long, ByVal wMsgFilterMin As Long, ByVal wMsgFilterMax As Long) As Long
Public Declare Function IsDialogMessage Lib "user32" Alias "IsDialogMessageA" (ByVal hDlg As Long, lpMsg As Msg) As Long
Public Declare Sub PostQuitMessage Lib "user32" (ByVal nExitCode As Long)
Public Declare Function GetFocus Lib "user32" () As Long
Public Declare Function SetFocus Lib "user32" (ByVal hwnd As Long) As Long

Public Const WS_VISIBLE = &H10000000
Public Const WS_TABSTOP = &H10000
Public Const WS_CHILD = &H40000000

Public Type POINTAPI
        x As Long
        y As Long
End Type
Public Type Msg
    hwnd As Long
    message As Long
    wParam As Long
    lParam As Long
    time As Long
    pt As POINTAPI
End Type

'-------------------------
Public Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Public Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hwnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Public Const GWL_WNDPROC = (-4)
Public Const WM_GETDLGCODE = &H87
Public Const DLGC_WANTCHARS = &H80
'-------------------------

Dim hwndButton  As Long

Dim prev_proc As Long

Public Function button_proc(ByVal hwnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
    Select Case Msg
    Case WM_GETDLGCODE
        button_proc = DLGC_WANTCHARS
        Exit Function
    End Select
    button_proc = CallWindowProc(prev_proc, hwnd, Msg, wParam, lParam)
End Function


Public Sub Main()
Dim mmsg  As Msg
Dim hwnd As Long
    Form1.Show
    hwnd = Form1.hwnd
    hwndButton = CreateWindowEx(0, "BUTTON", "Button", WS_VISIBLE Or WS_TABSTOP Or WS_CHILD, 100, 100, 100, 50, hwnd, 0, App.hInstance, 0)
    '-------------------------
    prev_proc = SetWindowLong(hwndButton, GWL_WNDPROC, AddressOf button_proc)
    '-------------------------
    
    Do While (GetMessage(mmsg, 0, 0, 0))
        If (Not IsDialogMessage(hwnd, mmsg)) Then
            Call TranslateMessage(mmsg)
            Call DispatchMessage(mmsg)
        End If
    Loop
End Sub





